unit MainUnit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    StartLoggingButton: TButton;
    StopLoggingButton: TButton;
    CountLabel: TLabel;
    Label2: TLabel;
    Timer1: TTimer;
    procedure StartLoggingButtonClick(Sender: TObject);
    procedure StopLoggingButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    procedure UpdateClickCount;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

const
  SharedBufferSize=1024;   

  DLLName='hookDLL.dll';
  
  FileMappingName = 'WinHookSharedMemoryName';
  MutexName       = 'WinHookSyncMutexName';

procedure SetMsgHook; stdcall; external DLLName;
procedure DelMsgHook; stdcall; external DLLName;

var
  FileMappingHandle:THandle = 0;
  SyncMutexHandle:THandle = 0;
  SharedBuffer:pointer= nil;

function GetButtonHandle:THandle;
begin
  Result:=FindWindow('Shell_TrayWnd',0);    //
  Result:=FindWindowEx(Result,0,'BUTTON',0);// 
  {
  Result:=FindWindow(0,'');
  Result:=FindWindowEx(Result,0,0,'=');    // "=" 
  }
end;

procedure RunHook;
begin
  FileMappingHandle:=CreateFileMapping(INVALID_HANDLE_VALUE,0,PAGE_READWRITE,0,SharedBufferSize,FileMappingName);
  SharedBuffer:=MapViewOfFile(FileMappingHandle,FILE_MAP_WRITE,0,0,SharedBufferSize);
  ZeroMemory(SharedBuffer,SharedBufferSize);
  DWORD(SharedBuffer^):=GetButtonHandle;
  SyncMutexHandle:=CreateMutex(0,false,MutexName);
  SetMsgHook;
end;

procedure StopHook;
begin
  DelMsgHook;
  UnmapViewOfFile(SharedBuffer);
  CloseHandle(FileMappingHandle);
  CloseHandle(SyncMutexHandle);
end;


procedure TMainForm.StartLoggingButtonClick(Sender: TObject);
begin
  RunHook ;
  Timer1.Enabled:=true;
end;

procedure TMainForm.StopLoggingButtonClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
  StopHook;
end;

procedure TMainForm.UpdateClickCount;
begin
  WaitForSingleObject(SyncMutexHandle,INFINITE);
  //
  CountLabel.Caption:=IntToStr(DWORD(pointer(DWORD(SharedBuffer)+4)^));
  //
  ReleaseMutex(SyncMutexHandle);
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  UpdateClickCount;
end;

end.
