library hookDLL;

uses
  Windows, Messages, Sysutils;

const
  SharedBufferSize = 1024;//4 MB

  FileMappingName = 'WinHookSharedMemoryName';
  MutexName       = 'WinHookSyncMutexName';
  
var
  HookHandle: HHOOK = 0 ;
  FileMappingHandle:THandle = 0;
  SyncMutexHandle:THandle = 0;
  SharedBuffer:pointer = nil;

function CallWndProcHook(CODE, WParam, LParam: DWORD): DWORD; stdcall;
var
  _CurrMessage: TCWPStruct;
begin
  Result:=CallNextHookEx(HookHandle, CODE, WParam, LParam);

  if CODE=HC_ACTION then
   begin
    _CurrMessage:=PCWPStruct(LParam)^;
    if (_CurrMessage.hwnd=HWND(SharedBuffer^)) and
       (_CurrMessage.message=WM_MOUSEACTIVATE) and
       ((_CurrMessage.lParam shr 16)=WM_LBUTTONDOWN) then
     begin
      WaitForSingleObject(SyncMutexHandle,INFINITE);
      //
      Inc(DWORD(pointer(DWORD(SharedBuffer)+4)^));
      //
      ReleaseMutex(SyncMutexHandle);
     end;
   end;
end;

procedure SetMsgHook; stdcall; export;
begin
  if HookHandle=0 then
   begin
    HookHandle:=SetWindowsHookEx(WH_CALLWNDPROC, @CallWndProcHook, hInstance, 0);
    FileMappingHandle:=OpenFileMapping(FILE_MAP_WRITE,false,FileMappingName);
    SharedBuffer:=MapViewOfFile(FileMappingHandle,FILE_MAP_WRITE,0,0,SharedBufferSize);
    SyncMutexHandle:=OpenMutex(SYNCHRONIZE,False,MutexName);
   end;
end;

procedure DelMsgHook; stdcall; export;
begin
  if HookHandle <> 0 then
   begin
    UnhookWindowsHookEx(HookHandle);
    HookHandle:=0;
    UnmapViewOfFile(SharedBuffer);
    CloseHandle(FileMappingHandle);
    CloseHandle(SyncMutexHandle);
    FileMappingHandle:=0;
   end; 
end;

exports
  SetMsgHook, DelMsgHook;

procedure DLLEntryPoint(dwReason:DWord);
begin
  case dwReason of
   DLL_PROCESS_ATTACH:
    if FileMappingHandle=0 then
     begin
      FileMappingHandle:=OpenFileMapping(FILE_MAP_WRITE,false,FileMappingName);
      SharedBuffer:=MapViewOfFile(FileMappingHandle,FILE_MAP_WRITE,0,0,SharedBufferSize);
      SyncMutexHandle:=OpenMutex(SYNCHRONIZE,False,MutexName);
     end;
   DLL_PROCESS_DETACH:
    begin
     UnmapViewOfFile(SharedBuffer);
     CloseHandle(FileMappingHandle);
     CloseHandle(SyncMutexHandle);
    end;
   end;
end;

begin
   DllProc:= @DLLEntryPoint; 
   DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
 