library hookDLL;

uses
  Windows, Messages, Sysutils;

const
  SharedBufferSize = 1024;

  FileMappingName = 'WinHookSharedMemoryName';
  MutexName       = 'WinHookSyncMutexName';
  
var
  HookHandle: HHOOK = 0 ;
  FileMappingHandle:THandle = 0;
  SharedBuffer:pointer = nil;

function GetMsgProcHook(CODE, WParam, LParam: DWORD): DWORD; stdcall;
var
  _msg:PMsg;
begin 
  if CODE=HC_ACTION then
   begin
    _msg:=PMsg(LParam);
    if (_msg^.hwnd=HWND(SharedBuffer^)) then
     if (_msg^.message=WM_KEYDOWN) or (_msg^.message=WM_KEYUP) then
      if _msg.wParam=ord('1') then _msg.wParam:=ord('2');
   end;
  Result:=CallNextHookEx(HookHandle, CODE, WParam, LParam);   
end;

procedure SetMsgHook; stdcall; export;
begin
  if HookHandle=0 then
   begin
    HookHandle:=SetWindowsHookEx(WH_GETMESSAGE, @GetMsgProcHook, hInstance, 0);
    FileMappingHandle:=OpenFileMapping(FILE_MAP_WRITE,false,FileMappingName);
    SharedBuffer:=MapViewOfFile(FileMappingHandle,FILE_MAP_WRITE,0,0,SharedBufferSize);
   end;
end;

procedure DelMsgHook; stdcall; export;
begin
  if HookHandle <> 0 then
   begin
    UnhookWindowsHookEx(HookHandle);
    HookHandle:=0;
    UnmapViewOfFile(SharedBuffer);
    CloseHandle(FileMappingHandle);
    FileMappingHandle:=0;
   end; 
end;

exports
  SetMsgHook, DelMsgHook;

procedure DLLEntryPoint(dwReason:DWord);
begin
  case dwReason of
   DLL_PROCESS_ATTACH:
    if FileMappingHandle=0 then
     begin
      FileMappingHandle:=OpenFileMapping(FILE_MAP_WRITE,false,FileMappingName);
      SharedBuffer:=MapViewOfFile(FileMappingHandle,FILE_MAP_WRITE,0,0,SharedBufferSize);
     end;
   DLL_PROCESS_DETACH:
    begin
     UnmapViewOfFile(SharedBuffer);
     CloseHandle(FileMappingHandle);
    end;
   end;
end;

begin
   DllProc:= @DLLEntryPoint; 
   DLLEntryPoint(DLL_PROCESS_ATTACH);
end.
 